#norootforbuild

%define prefix     /usr

Name:		   autoscan
Version:	   0.98.0b
Release:	   1
Summary:	   Utility for network exploration (Samba,Nessus client).
Source0:	   %{name}-%{version}.tar.gz
Copyright:	   GPL
Packager:	   Jonh Arson <jonharson@gmail.com>
Group:		   Networking/Other
URL:		   http://autoscan.free.fr
Requires:          samba-client
BuildRequires:     gnome-libs-devel libxml2 libxml2-devel
BuildRequires:     libzvt libzvt-devel net-snmp net-snmp-devel
BuildRequires:     samba smaba-client
BuildRoot:         %{_tmppath}/%{name}-%{version}-build
Distribution:      %(head -1 /etc/SuSE-release)

%description
AutoScan is an application designed to explore and to manage your network. Entire subnets can be scanned simultaneously without human intervention. It features OS detection, automatic network discovery, a port scanner, a Samba share browser, and the ability to save the network state.

%if %suse_version >= 930
%debug_package
%endif
%prep
%setup -q
%{?suse_update_libdir:%{suse_update_libdir}}
autoreconf -fi

%build
###
%__cd Sources/AutoScan/
./autogen.sh
%__cd src
%__make %{?_smp_flags}
%__cd ../../
%__cd AutoScan_Agent/
./autogen.sh
%__cd src
%__make %{?_smp_flags}

%install
%__install -d %{buildroot}/usr/share/doc/AutoScan/
%__install -d %{buildroot}/usr/share/pixmaps/AutoScan/
%__install -d %{buildroot}/usr/share/apps/AutoScan/
%__install -d %{buildroot}/usr/lib/menu/
%__install -d %{buildroot}/bin/
%__install -d %{buildroot}/usr/share/icons/
%__install -d %{buildroot}/usr/share/applications/

%__cd Sources/AutoScan/src/
%__install -m755 AutoScan_Network %{buildroot}/bin/
%__cd ../../
%__cd AutoScan_Agent/src/
%__install -m755 AutoScan_Agent %{buildroot}/bin/
%__cd ../../../Data/apps/AutoScan
%__install -m755 * %{buildroot}/usr/share/apps/AutoScan/
%__install -m755 AutoScan.desktop %{buildroot}/usr/share/applications/
%__cd ../../../Data/pixmaps/AutoScan
%__cp -R  * %{buildroot}/usr/share/pixmaps/AutoScan/
%__cp AutoScan.png  %{buildroot}/usr/share/icons/
%__cd ../../../Data/doc/AutoScan
%__install -m755 * %{buildroot}/usr/share/doc/AutoScan/

%find_lang "%{name}"

%suse_update_desktop_file

%clean
%__rm -rf "%{buildroot}"

%post
update-desktop-database %{_datadir}/applications
chmod +s /bin/AutoScan_Agent
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
SCHEMAS="AutoScan.schemas"
for S in $SCHEMAS; do
  gconftool-2 --makefile-install-rule /usr/share/apps/AutoScan/$S > /dev/null
done

%files -f "%{name}.lang"
%defattr(-, root, root)
%{_bindir}/*
%{_datadir}/apps/AutoScan/*
%{_datadir}/doc/AutoScan/*
%{_datadir}/pixmaps/AutoScan/*
%{_datadir}/icons/*
%{_datadir}/applications/*

%changelog
* Mon Jan 30 2006 Jonh Arson <jonharson@gmail.com>
- 
