/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef __CKECK_MALLOC_ENABLE

#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "Mem.h"
#include "Log.h"
#include "main.h"
#include "Quit.h"	



#define VALEUR_MAGIQUE	0x12345678L

static void *pointeur_malloc = NULL;
static void *pointeur_realloc = NULL;
static void *pointeur_free = NULL;


#ifdef __LOG_ENABLE
extern struct Struct_Categorie Liste_Categorie[];
#endif



gint Emplacement_Libre_Liste_Malloc (void){
	gint i;
	
	for (i=0;i<TAILLE_LISTE_MALLOC;i++){
		if (List_Malloc[i]==NULL)
			return i;
	}
	printf("List_Malloc : Pleine\n");
	exit(-1);
}

gint Emplacement_Element_Liste_Malloc (struct struct_Malloc *Donnee_Malloc){
	gint i;
	
	for (i=0;i<TAILLE_LISTE_MALLOC;i++){
		if (List_Malloc[i]==Donnee_Malloc)
			return i;
	}
	return -1;
}




static int verifie_pointeur (void *pointeur)
{
	long      taille;

	if (pointeur == NULL)
		return 1;
	if (*(long *) (pointeur - sizeof (long)) != VALEUR_MAGIQUE)
		return 0;
	taille = *(long *) (pointeur - 2 * sizeof (long));
	if (*(long *) (pointeur + taille) != VALEUR_MAGIQUE)
		return 0;
	if (*(long *) (pointeur + taille + sizeof (long)) != VALEUR_MAGIQUE)
		return 0;
	return 1;
}

gint Check_memoire (void)
{
	struct struct_Malloc *Donnee_Malloc = NULL, *Trouve = NULL;
	struct Struct_Liste_Equipement* Equipement = NULL;
	gint      i, Nb_Objet_Liste;
	gint Nb_Anomalie;

	Nb_Anomalie = 0;
	for (i = 0; i < TAILLE_LISTE_MALLOC; i++) {
		Donnee_Malloc = List_Malloc[i];
		if (!verifie_pointeur (Donnee_Malloc->bloc + 2 * sizeof(long))){
			printf("########################################################\n");
			printf("Memory corruption : Id[%d]   @[%p]   Size[%d]\n",i,Donnee_Malloc->bloc,Donnee_Malloc->Taille);
			printf("Owner [%s]\n",Liste_Categorie[Donnee_Malloc->Categorie].Info);
			display_backtrace(NULL,Donnee_Malloc->Appel_Malloc,Donnee_Malloc->size);
			printf("########################################################\n");
			Nb_Anomalie ++;
		}
	}
	return Nb_Anomalie;
}


#define DATA_BLOC 20
struct struct_Malloc *Recherche_Struct_Malloc (void *bloc,gchar *Fonction,struct struct_Cle_Privee *pCle, void *pointeur, void *appel)
{
	struct struct_Malloc *Donnee_Malloc = NULL, *Trouve;
	gchar     Data[DATA_BLOC],*pbloc;
	gint      *pblocInt;
	gint      i, Nb_Objet_Liste;

	Trouve = NULL;
	for (i = 0; i < TAILLE_LISTE_MALLOC; i++) {
		Donnee_Malloc = List_Malloc[i];
		if (Donnee_Malloc!=NULL){
			if (Donnee_Malloc->bloc == bloc){
				Trouve = Donnee_Malloc;
				return Trouve; 
			}
			/*if (!verifie_pointeur (Donnee_Malloc->bloc + (2 * sizeof(long)))){
				printf("Memory corruption : %d   [%p]\n",i,Donnee_Malloc->bloc);
				Arret_Demande_Mem_Failed (pCle, "%s(%p) : Memory corruption   appel (%p)", Fonction, pointeur, appel);
			}*/
		}
	}
/*	if (Trouve == NULL){
	
		pbloc = bloc + (2 * sizeof(long));
		for (i=0;i<DATA_BLOC-2;i++) {
			if ((pbloc[i] > 32) && (pbloc[i] < 126))
				Data[i] = pbloc[i];
			else
				Data[i] = '.';
		}
		Data[DATA_BLOC-2] = 0;
		pblocInt = bloc + (2 * sizeof(long));
		printf("%s  Id_Thread (%p) [%s]: Unkown pointer  appel (%p)     Data [%s]   Int[%d-%d-%d-%d-%d-%d]\n", Fonction,pthread_self(),Liste_Categorie[pCle->Categorie].Info, appel,Data,pblocInt[0],pblocInt[1],pblocInt[2],pblocInt[3],pblocInt[4],pblocInt[5]);
	
	}*/
	return Trouve;
}


static void *mon_malloc (size_t taille, void *appel)
{
	struct struct_Malloc *Donnee_Malloc = NULL;
	struct struct_Cle_Privee *pCle = NULL;
	void     *bloc = NULL;


	if(!pthread_equal( pthread_self(), mainThreadId )){
		printf("mon_malloc : Uniquement le thread Main a le droit de faire un malloc\n");
		RESTITUTION_POINTEURS ();
		display_backtrace(NULL,NULL,0);
		exit(-1);
	}

	RESTITUTION_POINTEURS ();


	pCle = Donnee_Cle_Main;

	bloc = malloc (taille + 4 * sizeof (long));
	

	Donnee_Malloc = (struct struct_Malloc *) malloc (sizeof (struct struct_Malloc));
	bzero (Donnee_Malloc, sizeof (struct struct_Malloc));
	Donnee_Malloc->bloc = bloc;
	Donnee_Malloc->Categorie = pCle->Categorie;
	Donnee_Malloc->Pointeur_Data = pCle->Pointeur_Data;
	Donnee_Malloc->Taille = taille;
	Donnee_Malloc->size = backtrace (Donnee_Malloc->Appel_Malloc, MAX_BACKTRACE_SIZE);
	List_Malloc[Emplacement_Libre_Liste_Malloc()] = Donnee_Malloc; 
	

	pCle->Nb_Appel_Malloc++;
	pCle->Taille_Allouer = pCle->Taille_Allouer + taille;
	SAUVEGARDE_POINTEURS ();
	INSTALLATION_ROUTINES ();
	if (bloc == NULL){
		return NULL;
	}

	*(long *) bloc = taille;
	*(long *) (bloc + sizeof (long)) = VALEUR_MAGIQUE;
	*(long *) (bloc + taille + 2 * sizeof (long)) = VALEUR_MAGIQUE;
	*(long *) (bloc + taille + 3 * sizeof (long)) = VALEUR_MAGIQUE;

	return (bloc + 2 * sizeof (long));
}



static void *mon_realloc (void *ancien, size_t taille, void *appel)
{
	struct struct_Malloc *Donnee_Malloc = NULL;
	struct struct_Cle_Privee *pCle = NULL;
	void     *bloc = NULL;
	

	if(!pthread_equal( pthread_self(), mainThreadId )){
		printf("mon_realloc : Uniquement le thread Main a le droit de faire un realloc\n");
		RESTITUTION_POINTEURS ();
		display_backtrace(NULL,NULL,0);
		exit(-1);
	}

	RESTITUTION_POINTEURS ();


	pCle = Donnee_Cle_Main;

	if (ancien != NULL){
		Donnee_Malloc = Recherche_Struct_Malloc (ancien - 2 * sizeof (long),"mon_realloc",pCle, ancien, appel);
		if (Donnee_Malloc!=NULL){
		
		
		
		
			bloc = realloc (ancien - 2 * sizeof (long), taille + 4 * sizeof (long));
			Donnee_Malloc->bloc = bloc;
			Donnee_Malloc->Taille = taille;
		}
		else {  
		
			printf("mon_realloc : Bloc inconnu\n");
			bloc = realloc (ancien,taille);
			SAUVEGARDE_POINTEURS ();
			INSTALLATION_ROUTINES ();
			return bloc;
		}
	}
	else 
	
		bloc = malloc (taille + 4 * sizeof (long));
	
		Donnee_Malloc = (struct struct_Malloc *) malloc (sizeof (struct struct_Malloc));
		bzero (Donnee_Malloc, sizeof (struct struct_Malloc));
		Donnee_Malloc->bloc = bloc;
		Donnee_Malloc->Categorie = pCle->Categorie;
		Donnee_Malloc->Pointeur_Data = pCle->Pointeur_Data;
		Donnee_Malloc->Taille = taille;
		Donnee_Malloc->size = backtrace (Donnee_Malloc->Appel_Malloc, MAX_BACKTRACE_SIZE);
		List_Malloc[Emplacement_Libre_Liste_Malloc()] = Donnee_Malloc; 
	}

	pCle->Nb_Appel_Realloc++;
	pCle->Taille_Allouer = pCle->Taille_Allouer + taille;
	SAUVEGARDE_POINTEURS ();
	INSTALLATION_ROUTINES ();
	if (bloc == NULL){
		return bloc;
	}

	*(long *) bloc = taille;
	*(long *) (bloc + sizeof (long)) = VALEUR_MAGIQUE;
	*(long *) (bloc + taille + 2 * sizeof (long)) = VALEUR_MAGIQUE;
	*(long *) (bloc + taille + 3 * sizeof (long)) = VALEUR_MAGIQUE;

	return (bloc + 2 * sizeof (long));
}


static void mon_free (void *pointeur, void *appel)
{
	struct struct_Malloc *Donnee_Malloc = NULL;
	struct struct_Cle_Privee *pCle = NULL;
	long      taille;
	gint Emplacement;
	

	if(!pthread_equal( pthread_self(), mainThreadId )){
		printf("mon_free : Uniquement le thread Main a le droit de faire un free\n");	
		RESTITUTION_POINTEURS ();
		display_backtrace(NULL,NULL,0);
		exit(-1);
	}

	if (pointeur == NULL)
		return;	

	RESTITUTION_POINTEURS ();


	pCle = Donnee_Cle_Main;

	Donnee_Malloc = Recherche_Struct_Malloc (pointeur - 2 * sizeof (long),"free",pCle, pointeur, appel);

	if (Donnee_Malloc!=NULL){
	
	
	
	
		taille = (*(long *) (pointeur - 2 * sizeof (long)));
	
		pCle->Nb_Appel_Free++;
		pCle->Taille_Liberer = pCle->Taille_Liberer + taille;
	
		free (pointeur - 2 * sizeof (long));  
	
	
		Emplacement = Emplacement_Element_Liste_Malloc(Donnee_Malloc);
		if (Emplacement!=-1)
			List_Malloc[Emplacement] = NULL;
		else
			printf("mon_free : Emplacement pas retrouve\n");
		free (Donnee_Malloc);
	}
	else {
		printf("[WARNING MEM] Free : Pointer Inconnu [%p]   Thread Free [%s]\n",pointeur,Liste_Categorie[pCle->Categorie].Info);
		free(pointeur);
	}

	SAUVEGARDE_POINTEURS ();
	INSTALLATION_ROUTINES ();
}


void Initialisation_Liste_Malloc (){
	gint i;
	
	for (i=0;i<TAILLE_LISTE_MALLOC;i++)
		List_Malloc[i] = NULL;	
}

void debug_memoire (void)
{
	GList_Malloc = NULL;
	SAUVEGARDE_POINTEURS ();
	INSTALLATION_ROUTINES ();
}


void debug_memoire_disable (void)
{
	RESTITUTION_POINTEURS ();
}



void Vidage_Memoire (void)
{
	struct struct_Malloc *Donnee_Malloc = NULL;
	char    **strings = NULL;
	gchar    *pointeur = NULL,*Chemin = NULL;
	gchar    *Integrite = NULL, Temp[255], Bloc[200 + 1 + 2];
	DIR      *dir = NULL;
	gint      Nb_Objet_Liste, i, j, Taille;

	printf ("Vidage Mémoire\n");

	Chemin = g_strdup_printf ("%s/.autoscan-network/Log", Info_User->pw_dir);
	dir = opendir (Chemin);
	if (dir == NULL) {
	
		if (mkdir (Chemin, 0766) != 0) {
			printf ("ERROR : Save log  (mkdir)\n");
			exit (-1);
		}
		dir = opendir (Chemin);
		if (dir == NULL) {
			printf ("ERROR : Save log  (opendir)\n");
			exit (-1);
		}
	}
	closedir (dir);
	g_free (Chemin);

	Chemin = g_strdup_printf ("%s/.autoscan-network/Log/autoscan-network-mem", Info_User->pw_dir);
	fd_Fichier_Log = open (Chemin, O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (fd_Fichier_Log < 0) {
		printf ("ERROR : Create log  (open)\n");
		exit (-1);
	}
	g_free (Chemin);

	Nb_Objet_Liste = g_list_length (GList_Malloc);
	Ecriture_Fichier (fd_Fichier_Log, "**************** Vidage Mémoire *************************");
	sprintf (Temp, "Nb de malloc = %d", Nb_Objet_Liste);
	Ecriture_Fichier (fd_Fichier_Log, Temp);
	Ecriture_Fichier (fd_Fichier_Log, "*********************************************************");
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Donnee_Malloc = g_list_nth_data (GList_Malloc, i);
		if (!verifie_pointeur (Donnee_Malloc->bloc + (2 * sizeof (long))))
			Integrite = "FAILED";
		else
			Integrite = "OK";
	
		sprintf (Temp, "[%p](%04d)->%30s  [%6s]", Donnee_Malloc->bloc, Donnee_Malloc->Taille, Liste_Categorie[Donnee_Malloc->Categorie].Info, Integrite);
		Ecriture_Fichier_Sans_Retour_Chariot (fd_Fichier_Log, Temp);
	
		pointeur = Donnee_Malloc->bloc + (2 * sizeof (long));
		Taille = Donnee_Malloc->Taille;
		if (Taille > 200)
			Taille = 200;
		Bloc[0] = '[';
		for (j = 0; j < Taille; j++)
			if ((pointeur[j] > 32) && (pointeur[j] < 126))
				Bloc[j + 1] = pointeur[j];
			else
				Bloc[j + 1] = '.';
		Bloc[Taille] = ']';
		Bloc[Taille + 1] = 0;
		Ecriture_Fichier_Sans_Retour_Chariot (fd_Fichier_Log, Bloc);
	
		if ((Donnee_Malloc->size <= MAX_BACKTRACE_SIZE) && (Donnee_Malloc->size > 1)) {
		
			Ecriture_Fichier (fd_Fichier_Log, "");
			for (j = 0; j < Donnee_Malloc->size; j++) {
				sprintf (Temp, " %p ", Donnee_Malloc->Appel_Malloc[j]);
				Ecriture_Fichier_Sans_Retour_Chariot (fd_Fichier_Log, Temp);
			}
		
		}
	
		Ecriture_Fichier (fd_Fichier_Log, "");
	}
	close (fd_Fichier_Log);
	fd_Fichier_Log = 0;
	printf ("Vidage Mémoire : OK\n");
}
#endif
