/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __MEM
#define         __MEM

#ifdef __CKECK_MALLOC_ENABLE

#include <glib.h>
#include <malloc.h>
#include "Thread.h"
#include "Semaphore.h"


#define RESTITUTION_POINTEURS()	__malloc_hook = pointeur_malloc; \
				__realloc_hook = pointeur_realloc; \
				__free_hook = pointeur_free;

#define SAUVEGARDE_POINTEURS()	pointeur_malloc = __malloc_hook; \
				pointeur_realloc = __realloc_hook; \
				pointeur_free = __free_hook;

#define INSTALLATION_ROUTINES()	__malloc_hook = mon_malloc; \
				__realloc_hook = mon_realloc; \
				__free_hook = mon_free



#define MAX_BACKTRACE_SIZE 30

struct struct_Malloc {
	void     *bloc;
	gint      Categorie;
	void     *Pointeur_Data;
	gint      Taille;
	void     *Appel_Malloc[MAX_BACKTRACE_SIZE];
	size_t    size; 
};

GList    *GList_Malloc; 
#define TAILLE_LISTE_MALLOC 50000
struct struct_Malloc *List_Malloc[TAILLE_LISTE_MALLOC];
	

void      debug_memoire (void);
void      debug_memoire_disable (void);
static void *mon_malloc (size_t taille, void *appel);
static void *mon_realloc (void *ancien, size_t taille, void *appel);
static void mon_free (void *pointeur, void *appel);
static int verifie_pointeur (void *pointeur);
void      Vidage_Memoire (void);
void 	*Malloc2  (size_t taille, void *appel);
void 	*Realloc2 (void *ancien, size_t taille, void *appel);
void 	Free2 (void *pointeur, void *appel);
void Initialisation_Liste_Malloc ();
gint Check_memoire (void);
#endif

#endif
